/**
 * JASMINe
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.monitoring.eos.notification.view.components
{
import mx.collections.ArrayCollection;

public class MultiFilterArrayCollection extends ArrayCollection
{
  private var _filterFunctions:Array;

  public function MultiFilterArrayCollection(source:Array=null)
  {
    super(source);
  }

  public function set filterFunctions( filtersArray:Array ):void
  {
    _filterFunctions = filtersArray;
    this.filterFunction = complexFilter;
  }
  public function get filterFunctions():Array
  {
    return _filterFunctions;
  }

  protected function complexFilter( item:Object ):Boolean
  {
    var filterFlag:Boolean = true;
    var filter:Function;
    for each(filter in filterFunctions)
    {
      filterFlag = filter( item );
      if( !filterFlag )
        return filterFlag;
    }
    return filterFlag;
  }

} //class
} //package