/**
 * JASMINe
 * Copyright (C) 2008 Bull S.A.S.
 * Contact: jasmine@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */
package org.ow2.jasmine.monitoring.eos.notification.vo
{
import com.adobe.cairngorm.vo.IValueObject;

import mx.collections.ArrayCollection;


/**
 * @author radua
 */

/**
 * The ejb JasmineEventNotification is translated to actionscript
 * via the object JasmineEventNotificationVO.
 */
[Bindable]
/**
 *
 * @author guillaume
 */
public class JasmineEventNotificationVO implements IValueObject
{
    
    /*********************************************
     * Getters and setters.                      *
     *********************************************/
    
    /**
     * notification id.
     */
    private var paramID : String;


    public function JasmineEventNotificationVO() {
    }

    public function set id(id : String) : void
    {
        this.paramID = id;
    }
    
    
    
    public function get id() : String
    {
        return this.paramID;
    }
    
    /**
     * notification level.
     *
     * In the java class, this parameter is a String. However, in the model,
     * this value is overloaded and a LevelSettingVO is set. Therefore, the
     * variable is Transient as it has no equivalent in JAVA.
     */
    private var paramLevel : LevelSettingVO;
    
    [Transient]
    public var levelName : String = "";
    
    
    
    [Transient]
    public function set level(_level : LevelSettingVO) : void
    {
        this.paramLevel = _level;
        this.levelName = _level.level;
    }
    
    
    
    public function get level() : LevelSettingVO
    {
        return this.paramLevel;
    }
    
    /**
     * date when the noti was triggered.
     */
    private var paramDate : Date;
    
    
    
    public function set date(date : Date) : void
    {
        this.paramDate = date;
    }
    
    
    
    public function get date() : Date
    {
        return this.paramDate;
    }
    
    /**
     * message associated with the notif.
     */
    private var paramMessage : String;
    
    
    
    public function set message(message : String) : void
    {
        this.paramMessage = message;
    }
    
    
    
    public function get message() : String
    {
        return this.paramMessage;
    }
    
    /**
     * notification status: acknowledged or not.
     */
    private var paramStatus : Boolean;
    
    
    
    public function set status(status : Boolean) : void
    {
        this.paramStatus = status;
    }
    
    
    
    public function get status() : Boolean
    {
        return this.paramStatus;
    }
    
    /**
     * the rule that triggered the notif.
     */
    private var paramRule : String;
    
    
    
    public function set rule(rule : String) : void
    {
        this.paramRule = rule;
    }
    
    
    
    public function get rule() : String
    {
        return this.paramRule;
    }
    
    /**
     * the details of the notification, used for specific actions.
     */
    
    private var paramDetails : ArrayCollection;
    
    
    
    public function set details(details : ArrayCollection) : void
    {
        this.paramDetails = details;
    }
    
    
    
    public function get details() : ArrayCollection
    {
        return this.paramDetails;
    }
    
    
    
    /**
     * Check if the details contain the property, and return its value if yes, N/A otherwise
     *
     * @param searchedLabel The property to get the message of.
     * @return The value of the property, N/A otherwise.
     */
    public function hasDetail(searchedLabel : String) : String
    {
        for each (var detail : JasmineEventNotificationDetailVO in this.details)
        {
            if (detail.label == searchedLabel)
            {
                return detail.message;
            }
        }
        return "N/A";
    }
    
    /**
     * Actions executed on the notification.
     */
    private var actionsObj : ArrayCollection;
    
    
    
    public function set actions(_actions : ArrayCollection) : void
    {
        this.actionsObj = _actions;
    }
    
    
    
    public function get actions() : ArrayCollection
    {
        return this.actionsObj;
    }

}
}
